import*as React from'react';import {useState}from'react';import {filter}from'lodash-es';import {Form,Row,Col,Button,Input,Layout}from'antd';import {ChartList}from'./ChartList.js';import {RepositorySelector}from'../containers/RepositorySelector.js';const {
  Item
} = Form;
const {
  Search
} = Input;
const {
  Content
} = Layout;
const styles = {
  container: props => ({
    padding: '15px',
    overflowY: 'auto',
    background: '#fff',
    height: 'calc(100vh - 64px)'
  })
};
function ChartsDashboard({
  data,
  loading,
  repository,
  onChangeRepository,
  onClkUploadChart
}) {
  const [form] = Form.useForm();
  const values = form.getFieldsValue();
  const [keyword, setKeyword] = useState('');
  const [filteredCharts, setFilteredCharts] = useState(null);
  if (!data) {
    data = {};
  }
  const onSearch = e => {
    e.preventDefault();
    const filterWord = e.target.value;
    const fCharts = filter(data.getCharts, chart => {
      return chart.name.includes(filterWord);
    });
    setKeyword(filterWord);
    setFilteredCharts(fCharts);
  };
  const onView = () => {};
  const onInstall = () => {};
  return React.createElement(Content, null, React.createElement(Row, {
    gutter: 16
  }, React.createElement(Col, {
    md: 6
  }, React.createElement(Button, {
    type: "primary",
    onClick: onClkUploadChart
  }, "Upload Chart")), React.createElement(Col, {
    md: 6
  }, React.createElement(Item, {
    name: 'repository',
    label: "Repository",
    required: true,
    initialValue: repository
  }, React.createElement(RepositorySelector, {
    style: {
      width: '100%'
    },
    onChange: onChangeRepository
  }))), React.createElement(Col, {
    md: 6
  }, React.createElement(Item, null, React.createElement(Search, {
    disabled: !values.repository,
    placeholder: "Chart search...",
    onChange: onSearch
  })))), React.createElement("div", {
    className: styles.container
  }, React.createElement(ChartList, {
    loading: loading,
    repository: repository,
    charts: keyword === '' ? data.getCharts || [] : filteredCharts || [],
    onInstall: onInstall,
    onView: onView
  })));
}export{ChartsDashboard};//# sourceMappingURL=ChartsDashboard.js.map
