import {map,includes,get}from'lodash-es';import*as React from'react';import {Table,Input,Button}from'antd';import {SearchOutlined}from'@ant-design/icons';function ImageSelectorComponent({
  images,
  loading,
  selected,
  onSelect,
  renderTagSelector,
  ...rest
}) {
  const [searchText, setSearchText] = React.useState({
    searchText: ''
  });
  const searchInput = React.useRef();
  const keys = React.useMemo(() => map(selected, ({
    id,
    chartName
  }) => !chartName ? id : `${chartName}`), [selected]);
  const handleSearch = (selectedKeys, confirm) => {
    confirm();
    setSearchText({
      searchText: selectedKeys[0]
    });
  };
  const handleReset = clearFilters => {
    clearFilters();
    setSearchText({
      searchText: ''
    });
  };
  const getColumnSearchProps = dataIndex => ({
    filterDropdown: ({
      setSelectedKeys,
      selectedKeys,
      confirm,
      clearFilters
    }) => React.createElement("div", {
      style: {
        padding: 8
      }
    }, React.createElement(Input, {
      ref: searchInput,
      placeholder: `Search ${dataIndex}`,
      value: selectedKeys[0],
      onChange: e => setSelectedKeys(e.target.value ? [e.target.value] : []),
      onPressEnter: () => handleSearch(selectedKeys, confirm),
      style: {
        width: 188,
        marginBottom: 8,
        display: 'block'
      }
    }), React.createElement(Button, {
      type: "primary",
      onClick: () => handleSearch(selectedKeys, confirm),
      icon: "search",
      size: "small",
      style: {
        width: 90,
        marginRight: 8
      }
    }, "Search"), React.createElement(Button, {
      onClick: () => handleReset(clearFilters),
      size: "small",
      style: {
        width: 90
      }
    }, "Reset")),
    filterIcon: filtered => React.createElement(SearchOutlined, {
      style: {
        color: filtered ? '#1890ff' : undefined
      }
    }),
    onFilter: (value, record = {}) => get(record, dataIndex, '').toString().toLowerCase().includes(value.toLowerCase()),
    onFilterDropdownVisibleChange: visible => {
      if (visible && searchInput && searchInput.current) {
        setTimeout(() => searchInput.current.select());
      }
    }
  });
  const columns = React.useMemo(() => [{
    title: 'Image',
    ...getColumnSearchProps('name'),
    render: record => record.name
  }, {
    title: 'Version',
    render: record => renderTagSelector(record, {
      selected: includes(selected, !record.repository || !record.chartName ? record.id : `${record.repository}/${record.chartName}`)
    })
    // ToDo: create component version selector
  }], []);
  const getKey = record => {
    return `${record.name}`;
  };
  return React.createElement(Table, {
    ...rest,
    rowKey: getKey,
    columns: columns,
    loading: loading,
    dataSource: images,
    rowSelection: {
      onSelect,
      selectedRowKeys: keys
    }
  });
}export{ImageSelectorComponent};//# sourceMappingURL=ImageSelector.js.map
