import*as _ from'lodash-es';import*as React from'react';import {useState,useEffect}from'react';import {useDispatch}from'react-redux';import {Subscription}from'rxjs';import {Form,Spin,Alert,Select,Input,Row,Col,Button}from'antd';import {useMutation}from'@apollo/client/react/index.js';import {testConnectionDocument}from'@ops-stack/core';import {useExtensionController}from'@adminide-stack/extension-api/lib/react/index.js';import {generateContributionId,parseTemplate,CONTRIBUTION_ACTION_TYPES}from'@adminide-stack/extension-api';const {
  Item
} = Form;
const {
  Option
} = Select;
const {
  TextArea
} = Input;
const styles = {
  buttonsContainer: props => ({
    display: 'flex',
    justifyContent: 'space-between'
  })
};
const RegistryFrom = ({
  registry,
  loading,
  onSubmit
}) => {
  const [testConnection, testResponse] = useMutation(testConnectionDocument);
  const [testResult, setTestResult] = useState(null);
  const [providerOptions, setProviderOptions] = useState([]);
  const [actions, setActions] = useState([]);
  const [selected, setSelected] = useState(null);
  const controller = useExtensionController();
  const subscriptions = new Subscription();
  const dispatch = useDispatch();
  const [form] = Form.useForm();
  const providers = [{
    name: 'ali-acr',
    isSuggest: true,
    isSelector: true,
    suggestions: [{
      name: 'cn-hangzhou',
      value: 'https://registry.cn-hangzhou.aliyuncs.com'
    }, {
      name: 'cn-shanghai',
      value: 'https://registry.cn-shanghai.aliyuncs.com'
    }, {
      name: 'cn-qingdao',
      value: 'https://registry.cn-qingdao.aliyuncs.com'
    }, {
      name: 'cn-beijing',
      value: 'https://registry.cn-beijing.aliyuncs.com'
    }, {
      name: 'cn-zhangjiakou',
      value: 'https://registry.cn-zhangjiakou.aliyuncs.com'
    }, {
      name: 'cn-huhehaote',
      value: 'https://registry.cn-huhehaote.aliyuncs.com'
    }, {
      name: 'cn-shenzhen',
      value: 'https://registry.cn-shenzhen.aliyuncs.com'
    }, {
      name: 'cn-chengdu',
      value: 'https://registry.cn-chengdu.aliyuncs.com'
    }, {
      name: 'cn-hongkong',
      value: 'https://registry.cn-hongkong.aliyuncs.com'
    }, {
      name: 'ap-southeast-1',
      value: 'https://registry.ap-southeast-1.aliyuncs.com'
    }, {
      name: 'ap-southeast-2',
      value: 'https://registry.ap-southeast-2.com'
    }, {
      name: 'ap-southeast-3',
      value: 'https://registry.ap-southeast-3.aliyuncs.com'
    }, {
      name: 'ap-southeast-5',
      value: 'https://registry.ap-southeast-5.aliyuncs.com'
    }, {
      name: 'ap-south-1',
      value: 'https://registry.ap-south-1.aliyuncs.com'
    }, {
      name: 'eu-central-1',
      value: 'https://registry.eu-central-1.aliyuncs.com'
    }, {
      name: 'eu-west-1',
      value: 'https://registry.eu-west-1.aliyuncs.com'
    }, {
      name: 'us-east-1',
      value: 'https://registry.us-east-1.aliyuncs.com'
    }, {
      name: 'me-east-1',
      value: 'https://registry.me-east-1.aliyuncs.com'
    }]
  }, {
    name: 'aws-ecr',
    isSuggest: true,
    isSelector: true,
    suggestions: [{
      name: 'ap-northeast-1',
      value: 'https://api.ecr.ap-northeast-1.amazonaws.com'
    }, {
      name: 'us-east-1',
      value: 'https://api.ecr.us-east-1.amazonaws.com'
    }, {
      name: 'us-east-2',
      value: 'https://api.ecr.us-east-2.amazonaws.com'
    }, {
      name: 'us-west-1',
      value: 'https://api.ecr.us-west-1.amazonaws.com'
    }, {
      name: 'us-west-2',
      value: 'https://api.ecr.us-west-2.amazonaws.com'
    }, {
      name: 'ap-east-1',
      value: 'https://api.ecr.ap-east-1.amazonaws.com'
    }, {
      name: 'ap-south-1',
      value: 'https://api.ecr.ap-south-1.amazonaws.com'
    }, {
      name: 'ap-northeast-2',
      value: 'https://api.ecr.ap-northeast-2.amazonaws.com'
    }, {
      name: 'ap-southeast-1',
      value: 'https://api.ecr.ap-southeast-1.amazonaws.com'
    }, {
      name: 'ap-southeast-2',
      value: 'https://api.ecr.ap-southeast-2.amazonaws.com'
    }, {
      name: 'ca-central-1',
      value: 'https://api.ecr.ca-central-1.amazonaws.com'
    }, {
      name: 'eu-central-1',
      value: 'https://api.ecr.eu-central-1.amazonaws.com'
    }, {
      name: 'eu-west-1',
      value: 'https://api.ecr.eu-west-1.amazonaws.com'
    }, {
      name: 'eu-west-2',
      value: 'https://api.ecr.eu-west-2.amazonaws.com'
    }, {
      name: 'eu-west-3',
      value: 'https://api.ecr.eu-west-3.amazonaws.com'
    }, {
      name: 'eu-north-1',
      value: 'https://api.ecr.eu-north-1.amazonaws.com'
    }, {
      name: 'sa-east-1',
      value: 'https://api.ecr.sa-east-1.amazonaws.com'
    }]
  }, {
    name: 'azure-acr',
    isSuggest: false
  }, {
    name: 'gitlab',
    isSuggest: false
  }, {
    name: 'google-gcr',
    isSuggest: true,
    isSelector: true,
    suggestions: [{
      name: 'https://gcr.io',
      value: 'https://gcr.io'
    }, {
      name: 'https://us.gcr.io',
      value: 'https://us.gcr.io'
    }, {
      name: 'https://eu.gcr.io',
      value: 'https://eu.gcr.io'
    }, {
      name: 'https://asia.gcr.io',
      value: 'https://asia.gcr.io'
    }]
  }, {
    name: 'harbor',
    isSuggest: false
  }, {
    name: 'helm-hub',
    isSuggest: true,
    isSelector: true,
    suggestions: [{
      name: 'https://hub.helm.sh',
      value: 'https://hub.helm.sh'
    }]
  }, {
    name: 'huawei-SWR',
    isSuggest: false
  }, {
    name: 'jfrog-artifactory',
    isSuggest: false
  }, {
    name: 'quay-io',
    isSuggest: false
  }];
  useEffect(() => {
    const id = generateContributionId();
    const contributionPoints = {
      contributions: {
        [id]: {
          actions: providers.map(provider => {
            return {
              id: provider.name,
              title: parseTemplate(provider.name),
              description: parseTemplate(JSON.stringify(provider))
            };
          }),
          menus: {
            'helm-registry/provider-drop-down': providers.map(provider => {
              return {
                action: provider.name
              };
            })
          }
        }
      }
    };
    // register contribution
    dispatch({
      type: CONTRIBUTION_ACTION_TYPES.REGISTER_CONTRIBUTIONS,
      payload: contributionPoints.contributions
    });
    form.setFieldsValue({
      credentials_type: 'login-password'
    });
    subscriptions.add(controller.services.contribution.getContributions().subscribe(contribution => {
      if (contribution.menus) {
        setProviderOptions(contribution.menus['helm-registry/provider-drop-down'] || []);
        setActions(contribution.actions || []);
      }
    }));
    return function unsubscribe() {
      dispatch({
        type: CONTRIBUTION_ACTION_TYPES.DEREGISTER_CONTRIBUTIONS,
        payload: contributionPoints.contributions
      });
      return subscriptions.unsubscribe();
    };
  }, []);
  useEffect(() => {
    if (registry.type && actions.length) {
      // const sIndex = _.findIndex(providers, provider => {
      //     return provider.name === registry.type;
      // });
      // setSelected(providers[sIndex]);
      const selectedAction = actions.find(data => data.id === registry.type);
      setSelected(JSON.parse(selectedAction && selectedAction.description));
    }
  }, [actions]);
  const submit = values => {
    onSubmit(values);
  };
  const test = e => {
    e.preventDefault();
    form.validateFields().then(values => {
      testConnection({
        variables: {
          payload: values
        }
      }).then(res => {
        if (res.data.testConnection) {
          setTestResult('success');
        } else {
          setTestResult('failed');
        }
      }).catch(error => setTestResult('failed'));
    }).catch(e => {
      console.log('Error', e);
    });
  };
  const onChangeType = type => {
    // const sIndex = _.findIndex(providers, provider => {
    //     return provider.name === type;
    // });
    // setSelected(providers[sIndex]);
    const selectedAction = actions.find(data => data.id === type);
    setSelected(JSON.parse(selectedAction && selectedAction.description));
    form.setFieldsValue({
      url: null
    });
  };
  return React.createElement(Spin, {
    spinning: loading
  }, React.createElement("br", null), testResponse.loading ? React.createElement(Spin, {
    spinning: true
  }) : testResult === 'success' ? React.createElement(Alert, {
    message: "Test Connection Success",
    type: "success",
    closable: true
  }) : testResult === 'failed' ? React.createElement(Alert, {
    message: "Test Connection Failed",
    type: "error",
    closable: true
  }) : null, React.createElement(Form, {
    form: form,
    onFinish: submit
  }, React.createElement(Item, {
    name: 'type',
    label: 'Provider',
    initialValue: registry.type,
    rules: [{
      required: true,
      message: 'Select Provider!'
    }]
  }, React.createElement(Select, {
    onChange: onChangeType
  }, providerOptions?.map((provider, index) => {
    const action = actions.find(data => data.id === provider.action);
    return React.createElement(Option, {
      value: action?.title,
      key: index
    }, action?.title);
  }))), React.createElement(Item, {
    name: 'name',
    label: 'Name',
    initialValue: registry.name,
    rules: [{
      required: true
    }]
  }, React.createElement(Input, {
    size: "large"
  })), React.createElement(Item, {
    name: 'description',
    label: 'Description',
    initialValue: registry.description,
    rules: [{
      required: true
    }]
  }, React.createElement(TextArea, {
    rows: 4
  })), React.createElement(Item, {
    name: 'url',
    label: "Url",
    initialValue: registry.url,
    rules: [{
      required: true,
      type: 'url',
      message: 'Please input url!!!'
    }]
  }, selected && selected.isSuggest && selected.isSelector ? React.createElement(Select, null, selected.suggestions?.map((suggestion, index) => React.createElement(Option, {
    value: suggestion.value,
    key: index
  }, suggestion.value))) : React.createElement(Input, {
    size: "large"
  })), React.createElement("p", null, "Login Credentials:"), React.createElement(Row, {
    gutter: 8
  }, React.createElement(Col, {
    md: 12
  }, React.createElement(Item, {
    name: 'access_key',
    label: "Access ID",
    initialValue: selected && selected.name === 'google-gcr' ? '_json_key' : _.get(registry, 'credentials.username')
  }, selected && selected.name === 'google-gcr' ? React.createElement(Input, {
    size: "large",
    disabled: true
  }) : React.createElement(Input, {
    size: "large"
  }))), React.createElement(Col, {
    md: 12
  }, React.createElement(Item, {
    name: 'access_secret',
    label: "Access Secret",
    initialValue: _.get(registry, 'credentials.password')
  }, React.createElement(Input, {
    size: "large",
    type: "password"
  })))), React.createElement("div", {
    className: styles.buttonsContainer
  }, React.createElement(Button, {
    size: "large",
    type: "text",
    onClick: test
  }, "Test Connection"), React.createElement(Button, {
    size: "large",
    type: "primary",
    htmlType: "submit"
  }, "Submit"))));
};
const RegistryFormComponent = RegistryFrom;export{RegistryFormComponent};//# sourceMappingURL=RegistryForm.js.map
