import'reflect-metadata';import React__default from'react';import {useParams}from'@remix-run/react';import {connect}from'react-redux';import {push}from'@common-stack/remix-router-redux';import {PageContainer}from'@admin-layout/ant-ui';import {IMenuPosition}from'@common-stack/client-react';import {getFilteredTabs,getFilteredRoutes}from'@adminide-stack/core';import {ChartView}from'./containers/ChartView.js';import {ChartsDashboard}from'./containers/ChartsDashboard.js';import {ImagesComponent}from'./containers/Images.js';import'lodash-es';import'antd';import'rxjs';import'@apollo/client/react/index.js';import {CompassOutlined,ApartmentOutlined}from'@ant-design/icons';import'@ops-stack/core';import'@adminide-stack/extension-api';import'@adminide-stack/extension-api/lib/react/index.js';import'moment';import'react-markdown';import'./components/ChartInstallation.js';import'@apollo/client/index.js';import {RepositoriesDashboard}from'./containers/RepositoriesDashboard.js';const ArtifactComponent = props => {
  const {
    orgName,
    teamName
  } = useParams();
  const tabItemPath = path => {
    const orgReplace = path.replace(':orgName', orgName);
    return teamName === undefined ? orgReplace : orgReplace.replace(':teamName', teamName);
  };
  const onTabChange = key => {
    props.push(key);
  };
  return React__default.createElement(PageContainer, {
    ...props,
    pageHeader: 'Artifacts',
    onTabChange: onTabChange,
    tabList: filteredTabs.map(tab => ({
      ...tab,
      key: tabItemPath(tab.path)
    })),
    tabActiveKey: props.location.pathname
  });
};
const Artifact = connect(null, {
  push
})(ArtifactComponent);
const chartsPageStore = [{
  key: 'repository',
  name: 'Repositories',
  path: '/o/:orgName/repository',
  icon: React__default.createElement(CompassOutlined, null),
  priority: 6,
  component: RepositoriesDashboard
}, {
  key: 'artifact',
  name: 'Artifact',
  tab: 'Artifact',
  path: '/o/:orgName/artifact',
  position: IMenuPosition.MIDDLE,
  icon: React__default.createElement(ApartmentOutlined, null),
  priority: 7,
  component: Artifact,
  exact: false
}, {
  key: 'artifact-helm-charts',
  name: 'Helm Charts',
  tab: 'Helm Charts',
  path: '/o/:orgName/artifact/helm-charts',
  exact: true,
  component: ChartsDashboard
}, {
  key: 'artifact-images',
  name: 'Images',
  tab: 'Images',
  path: '/o/:orgName/artifact/images',
  exact: true,
  component: ImagesComponent
}, {
  key: 'artifact-helm-chart',
  path: '/o/:orgName/artifact/helm-chart',
  name: 'Stack Chart',
  hideInMenu: true,
  tab: 'Stack Chart',
  exact: true,
  component: ChartView
}];
const selectedTabs = ['artifact-helm-charts', 'artifact-images'];
const filteredTabs = getFilteredTabs(chartsPageStore, selectedTabs);
const selectedRoutes = ['repository', 'artifact', 'artifact-helm-charts', 'artifact-helm-chart', 'artifact-images'];
// get routes
const filteredRoutes = getFilteredRoutes(chartsPageStore, selectedRoutes);export{chartsPageStore,filteredRoutes,filteredTabs};//# sourceMappingURL=compute.js.map
