import*as _ from'lodash-es';import {Modal}from'antd';import*as React from'react';import {useQuery}from'@apollo/client/react/index.js';import {getChartsDocument}from'@ops-stack/core';import {TagSelector}from'./TagSelector.js';import {InstallationModal}from'./InstallationModal.js';import'@remix-run/react';import'moment';import'react-markdown';import'@adminide-stack/core';import'../components/ChartInstallation.js';import'react-redux';import'rxjs';import'@adminide-stack/extension-api/lib/react/index.js';import'@adminide-stack/extension-api';import {ImageSelectorComponent}from'../components/ImageSelector.js';import'@admin-layout/ant-ui';import'@ant-design/icons';function ImageSelector({
  repository,
  values,
  onChange = [],
  ...rest
}) {
  const [modal, setModal] = React.useState(null);
  const {
    data,
    loading
  } = useQuery(getChartsDocument, {
    skip: !repository,
    variables: {
      repository
    }
  });
  const toggle = status => () => setModal(status);
  const select = (record, isSelected, images = []) => {
    if (isSelected) {
      setModal(record);
    } else {
      const filterImages = values.filter(item => item.chartName !== record.name);
      onChange(filterImages);
    }
  };
  const install = chart => {
    setModal(null);
    onChange(values.concat([chart]));
  };
  const selected = React.useMemo(() => values.map(c => Object.assign(c, {
    id: c.chartName
  })), [values]);
  const renderTagSelector = (image, options) => {
    return React.createElement(TagSelector, {
      image: image,
      repository: repository,
      selected: options.selected
    });
  };
  return React.createElement(React.Fragment, null, React.createElement(ImageSelectorComponent, {
    ...rest,
    loading: loading,
    onSelect: select,
    selected: selected,
    renderTagSelector: renderTagSelector,
    images: _.get(data, 'getCharts') || []
  }), React.createElement(Modal, {
    title: false,
    footer: false,
    visible: !!modal,
    destroyOnClose: true,
    style: {
      top: '15px'
    },
    onCancel: toggle(false)
  }, React.createElement(InstallationModal, {
    chart: modal,
    repository: repository,
    onInstall: install
  })));
}export{ImageSelector};//# sourceMappingURL=ImageSelector.js.map
