import React__default,{useState}from'react';import {useQuery,useMutation}from'@apollo/client/react/index.js';import {userRepositoriesDocument,createUserRepositoryDocument,removeUserRepositoryDocument}from'@ops-stack/core';import {GetOrgNameFromContextDocument}from'@adminide-stack/core';import'@remix-run/react';import {message}from'antd';import'lodash-es';import'moment';import'react-markdown';import'../components/ChartInstallation.js';import'react-redux';import'rxjs';import'@adminide-stack/extension-api/lib/react/index.js';import'@adminide-stack/extension-api';import'@ant-design/icons';import {NewRepositoryModal}from'../components/NewRepository.js';import {RepositoriesDashboard as RepositoriesDashboard$1}from'../components/RepositoriesDashboard.js';const RepositoriesDashboard = props => {
  const {
    loading: loadingContext,
    data: dataContext
  } = useQuery(GetOrgNameFromContextDocument);
  const [visible, setVisible] = useState(false);
  const {
    loading,
    data,
    refetch
  } = useQuery(userRepositoriesDocument, {
    variables: {
      orgName: dataContext ? dataContext.getOrgNameFromContext.orgName : ''
    }
  });
  const [createRepository, createReponse] = useMutation(createUserRepositoryDocument);
  const [removeRepository] = useMutation(removeUserRepositoryDocument);
  const handleNewRepo = values => {
    createRepository({
      variables: {
        repositoryName: values.name || '',
        orgName: dataContext ? dataContext.getOrgNameFromContext.orgName : ''
      }
    }).then(res => {
      message.success('Repository created!');
      closeModal();
      refetch();
    }).catch(err => {
      message.error('Repository creation failed!');
    });
  };
  const handleEditRepo = () => {};
  const handleRemoveRepo = repo => {
    removeRepository({
      variables: {
        repositoryId: repo.project_id
      }
    }).then(res => {
      refetch();
      message.success('Repository removed!');
    }).catch(err => {
      message.error('Repository removed failed!');
    });
  };
  const closeModal = () => {
    setVisible(false);
  };
  return React__default.createElement(React__default.Fragment, null, React__default.createElement(RepositoriesDashboard$1, {
    loading: loading || createReponse.loading,
    repositories: data?.userRepositories || [],
    openModal: () => setVisible(true),
    handleEditRepo: handleEditRepo,
    handleRemoveRepo: handleRemoveRepo
  }), React__default.createElement(NewRepositoryModal, {
    visible: visible,
    handleSubmit: handleNewRepo,
    onClose: closeModal,
    loading: createReponse.loading
  }));
};export{RepositoriesDashboard};//# sourceMappingURL=RepositoriesDashboard.js.map
