import React__default from'react';import {useQuery}from'@apollo/client/react/index.js';import {userRepositoriesDocument}from'@ops-stack/core';import {GetOrgNameFromContextDocument}from'@adminide-stack/core';import {RepositorySelectorComponent}from'../components/RepositorySelector.js';function RepositorySelector({
  onChange,
  ...rest
}) {
  const {
    data: dataContext
  } = useQuery(GetOrgNameFromContextDocument);
  const {
    loading,
    data,
    refetch
  } = useQuery(userRepositoriesDocument, {
    variables: {
      orgName: dataContext ? dataContext.getOrgNameFromContext.orgName : ''
    }
  });
  return React__default.createElement(RepositorySelectorComponent, {
    onChange: onChange,
    loading: loading,
    list: data ? data.userRepositories : [],
    ...rest
  });
}export{RepositorySelector};//# sourceMappingURL=RepositorySelector.js.map
